// Varna-2016, Task D

#include <iostream>
#include <algorithm>
using namespace std;

struct edge
{ int u,v;
  int x;
  int f;
};

bool operator<(edge e1, edge e2)
{ if(e1.f==0 && e2.f==1) return true;
  if(e1.f==1 && e2.f==0) return false;
  return e1.x < e2.x;
}

const int MAXN = 1000;
const int MAXM = 10000;

int n,m,k;
edge e[MAXM+1];
int c[MAXN];

int main()
{ int br;
  cin >> br;
  for(int test=1; test<=br; test++)
  { cin >> n >> m >> k;
    for(int i=1; i<=m; i++)
    { cin >> e[i].u
      >> e[i].v >> e[i].x;
      e[i].f = 0;//no flooded
    }
    for(int i=0; i<k; i++)
    { int p;
      cin >> p;
      e[p].f = 1;
    }

    sort(e+1,e+m+1);

    for(int u=0; u<n; u++)
      c[u] = u;

    int s = 0;
    for(int i=1; i<=m; i++)
    { int u=e[i].u, v=e[i].v;
      int p=c[u], q=c[v];
      if(p != q)
      { s = s + e[i].x*e[i].f;
        for(int j=0; j<n; j++)
          if(c[j]==q) c[j]=p;
      }
    }

    cout << s << endl;

  }

  return 0;
}
